Subject: Re: bug#19779: dmd: service definition errors cause kernel panic

From: [email-masked] (Ludovic Courtès)
Date: Wed, 25 Nov 2015 12:02:09 +0100

Mark H Weaver <[email-masked]> skribis:

> When I first wrote 'wicd-service', I mispelled
> 'make-forkexec-constructor'.  This caused a kernel panic whenever the
> service was included in my OS config.  I don't know whether dmd printed
> a helpful error message, but if so, it was followed immediately by a
> kernel call trace that caused earlier messages to scroll off the screen.
> The result is that it was quite difficult to find the source of the
> error.
>
> In case of such errors, it would be good if dmd would print an error
> message with the most useful information at the bottom (in case it does
> not all fit on the display) and then to avoid exiting so that the
> message could be read and understood.

Commit b9c7ed7 wraps service loading in ‘call-with-error-handling’,
which spawns a REPL when something goes wrong.  Better than a kernel
panic!

Ludo’.